#include "modechange.hpp"
#include "manager.hpp"
#include "rttask.hpp"
#include <cstdlib>
#include <cstdio>
#include <iostream>

using namespace std;


int main(int argc, char *argv[])
{
    ModeChangeData modeObj;

    cout << "------------------------" << endl;

    modeObj.setTaskModes(0, 0);
    modeObj.setTaskModes(1, 0);
    modeObj.setTaskModes(3, 0);

    modeObj.setTaskModes(1, 1);
    modeObj.setTaskModes(2, 1);
    modeObj.setTaskModes(4, 1);

    modeObj.setTaskModes(0, 2);
    modeObj.setTaskModes(2, 2);
    modeObj.setTaskModes(3, 2);

    cout << "Mode change created, the task mode table has been prepared" << endl;

    ModeManager mm(modeObj);
    mm.start();

    cout << "Mode manager started" << endl;
    
    PeriodicTask *p[5];
    long periods[5] = {
        200000,
        300000,
        500000,
        800000,
        1000000,
    };

    long ws[5] = {
        2000000,
        3000000,
        5000000,
        8000000,
        10000000,
    };
    
    int prio[5] = {
        10, 9, 8, 7, 6
    };

    for (unsigned i=0; i<5; i++) {
        p[i] = new PeriodicTask(i, prio[i], periods[i], ws[i], modeObj);
        p[i]->log("*********");
        p[i]->start();
    }

    bool flag = true;
    char c;
    while (flag) {
        c = getchar();
        switch(c) {
        case '0' :
            cout << "Switching to mode 0" << endl;
            mm.signal(0);
            break;
        case '1' :
            cout << "Switching to mode 1" << endl;
            mm.signal(1);
            break;
        case '2' :
            cout << "Switching to mode 2" << endl;
            mm.signal(2);
            break;
        case 'q' : 
            flag = false;
            break;
        default:
            break;
        }
    }
    
}
