#include "manager.hpp"

void *thread_manager(void *arg)
{
    ModeManager *mm = (ModeManager *)arg;
    mm->run();
    return NULL;
}

ModeManager::ModeManager(ModeChangeData &mc) : mcObj(mc), newMode(0)
{
    sem_init(&sem, 0, 0); 
}

pthread_t ModeManager::start()
{
    pthread_t tid;
    pthread_create(&tid, 0, thread_manager, this);
    return tid;
}

void ModeManager::run()
{
    while(1) {
        sem_wait(&sem);
        // nm contains the new mode
        mcObj.change(newMode);
        mcObj.activateAllTasks();
    }
}

void ModeManager::signal(int nm)
{
    newMode = nm;
    sem_post(&sem);
}

