#ifndef MODECHANGE_HPP
#define MODECHANGE_HPP

#include <pthread.h>

#ifndef NTASKS
#define NTASKS  5
#endif

#ifndef NMODES
#define NMODES  3
#endif

class ModeChangeData {
public:

    ModeChangeData();
    void setTaskModes(int i, int m);   // task i is active on mode m
    void change(int newMode);       // called by the manager, switch to new mode
    bool checkMode(int i);          // if task i is in current mode, returns true
                                    // else blocks and returns false when wakes up
    void activateAllTasks();        // activate all tasks in the new mode, completing the transition

protected:
    pthread_mutex_t mutex;
    pthread_cond_t tcond[NTASKS];  // array of condition variables
    bool array[NTASKS][NMODES];

    int cur_mode;
    int old_mode;
    
    int numOldTasks;
    int numSuspended;

    pthread_cond_t bmanager;
};

#endif
